BigBeam = Entity:extend()

function BigBeam:new(x, y, z, dx, dy, movemesh, group)
  Entity.new(self, x, y, z)

  self.dx = dx
  self.dy = dy
  self.img = G.core.images:load("data/sprites/bigbeam.png")
  local iw, ih = self.img:getDimensions()
  self.q = G.core.quads:make(0,0,iw, ih, iw, ih)

  self.attach = movemesh:locate(x, y, z)
	if not self.attach then
		self.dead = true

	else
		self.z = z

		local px, py = self.attach:cast_ray(dx, dy)
		self.len = lust.tools.length(x - px, y -py)

		--local spx0, spy0 = lus.tools.normalize(-dx, -dy)

		group:add(PlayerExplosion(px, py, self.z, self.attach.mesh, 
			100,
			{-10, -50, -20},
			{10, 50, 20}
			))

		self.t = 0
		self.flux = flux.group()
		self.scale = {x = 0.0}
		self.flux:to(self.scale, 0.08, {x = 1})
			:oncomplete(function()
				-- entity test
				local hit = {}

				local sx, sy = lust.tools.scale(self.dx, self.dy, self.len)
				local x2, y2 = projectPoint(sx + self.x, sy + self.y, self.z)
				local x1, y1 = projectPoint(self.x, self.y, self.z)

				for i, e in ipairs(self.group.children) do
					if not e:is(Player) then

						
					--  local d = lust.tools.point_line_distance(e.x, e.y, xy1[1], xy1[2], xy2[1], xy2[2])

	--          if circleLineIntersect(xy1, xy2, {e.x, e.y}, e.radius) then
	--          if d < e.radius +8 then
							local cx1, cy1, cx2, cy2 = e:getProjectedAABB()

							if cx1 and (lust.tools.line_line_intersection(cx1, cy1, cx1, cy2,  x1, y1, x2, y2)
								or lust.tools.line_line_intersection(cx2, cy1, cx2, cy2,  x1, y1, x2, y2)
								or lust.tools.line_line_intersection(cx1, cy1, cx2, cy1,  x1, y1, x2, y2)
								or lust.tools.line_line_intersection(cx1, cy2, cx2, cy2,  x1, y1, x2, y2)) then


							e:hurt(100)

						end
					end
				end


				self.flux:to(self.scale, 0.3, {x = 0})
				:delay(0.3)
				:oncomplete(function()
					self.dead = true
				end)
		end)
	end

end


function BigBeam:draw(renderer)
  local sx, sy = lust.tools.normalize(self.dx, self.dy)
  for i = 1, self.len, 3 do
    
    local s = self.scale.x
    local u = s * (1 + 1.5 * math.cos(math.max(0, math.min(math.pi/2, i/30))))
    local early_hack = self.dx == 0 and self.dy == 1
    renderer:add(self.img, self.q, 10, 10, self.x + i * sx, self.y + i * sy, self.z, "add", u, u, 255*s,255*s, 255*s, 255, early_hack)
  end
end


function BigBeam:update(dt)
  self.t = self.t + dt
  self.flux:update(dt)
end
