return {
	start = function(st)
		st.renderer.tint = {0,0,0}
		st:allowInput(false)
		local c = G.console
		G.console.allow_ff = true

		---[[
		c:print("S.E.N.T.I.N.E.L. BIOS v1.17.2", 2)
		c:beep(0)
		c:print("Power-on self test (POST)", 0.6)
		for i = 0, 1024, 4 do
			c:print("Memory: " .. (1024 * i) .. "M checked", 0.016, i > 1)
		end

		c:print("Detected anomalous memory blocks.")
		c:print("Isolating faulty memory area...", 0.1)
		c:print("Isolating faulty memory area...done", 1.3, true)
		c:print("Hardware checks:", 0.2)
		c:print("Mass storage:", 0.2)
		c:print("Mass storage:    present", 0.4, true)
		c:print("Cameras:", 0.2)
		c:print("Cameras:         present", 0.4, true)
		c:print("Audio processor:", 0.2)
		c:print("Audio processor: present", 0.4, true)
		c:print("Actuators:", 0.2)
		c:print("Actuators:       present", 0.4, true)
		c:print("Weapon systems:", 0.2)
		c:print("* B.A.D.A.S.S. Pulse Cannon:", 0.7)
		c:print("* B.A.D.A.S.S. Pulse Cannon: operational", 0.7, true)
		c:print("* Minigun turret:", 0.5)
		c:print("* Minigun turret:            offline", 0.2, true)

		c:print("", 0.6)
		c:print("Loading operating system...")
		
		--c:clear(2)
		--]]

		c:print("")
		c:print("")
		c:beep(0)
		c:beep(0.2)
		c:print("Realtime S.E.N.T.I.N.E.L. loaded")
		c:print("Kernel 2.8.4.74532")
		c:print("Built: 2015-12-13")
		c:print("Booting secondary CPU cores:")
		---[[
		for i = 1, 17 do
			local t = ""
			for j = 1, i do
				t = t .. " " .. ((j < 17) and j or "done")
			end
			c:print("  " .. t, 0.125, i > 1)
		end
		c:print("Loading primary mission database...")
		c:print("Loading primary mission database...failed", 2, true)
		c:error()
		c:print("Loading backup mission database...", 0.3)
		c:print("Loading backup mission database...done", 2, true)
		c:print("  WARNING! Mission database out of date", 1)
		c:print("")
		c:print("Opening SATCOM connection to HQ", 1)
		c:print("  WARNING! Connection failed.", 2)
		c:error()
		c:print("  WARNING! Using outdated mission DB.")
		c:print("")
		c:print("*************************************", 1)
		c:print("Mission objectives:")
		c:print("  1   Stop slime growth")
		c:print("  2   Establish SATCOM connection")
		c:print("*************************************")
		c:print("")
		c:print("Loading primary IFF database...")
		c:print("Loading primary IFF database...failed", 2, true)
		c:error()
		c:print("Loading backup IFF database...")
		c:print("Loading backup IFF database...done", 2, true)
		c:print("  WARNING! IFF database out of date", 1)
		c:print("  WARNING! Friend/Foe discrimination unreliable")
		c:error()
		c:print("")
		--]]
		c:print("Booting visual system...")
		c:barrier(function()
			st.tween:to(st.renderer.tint, 4, {[1]=255, [2]=255, [3]=255})
			end, 1)

		c:print("Vision stabilized", 4.5)
		c:print("")
		c:print("Starting B.A.D.A.S.S. preheating cycle", 1)
		c:barrier(function() G.sounds.badass_preheat:play()end)
		c:print("Calibrating actuator servo motors", 1)
		c:print("Starting SATCOM maintenance task [TID 32]", 1)
		c:print("SATCOM repair status: 0% done")
		c:print("")
		c:print("B.A.D.A.S.S. preheating done", 1)
		c:print("Enabling motor control", 0.4)
		c:print("", 0.5)
		c:print("*************************************")
		c:print("User comment:")
		c:print("  ** Arrow keys navigate")
		c:print("  ** [x] key fires B.A.D.A.S.S. Pulse Cannon")
		c:print("*************************************")
		c:print("")
		c:beep(0)
		c:barrier(function()
			st:allowInput(true)
		end)
		c:print("Hull integrity: 100%", 0.3)
		c:barrier(function()
			G.console.allow_ff = false
		end)
	end,

	Next_Level = function(st)
		local health = st.player.health
		local newst = IngameState("level02")
		newst.player.health = health
		G.core.states:replace(newst)
	end

}
