return {
	start = function(st)
		
		--[[
		for i, e in ipairs(st.entities.children) do
			if e:is(Slime) or e:is(SlimeBall) or e:is(SlimeCannon) then
				e. dead = true
			end
		end
		]]

		st.newimage = {
			G.core.images:load("data/level/level05a_color.png"),
			G.core.images:load("data/sprites/blood.png"),
			G.core.images:load("data/sprites/blood2.png")
		}

		

	end,

	update = function(st, dt)

		if st.outro_started then
			return
		end

		local count = 0
		for i, e in ipairs(st.entities.children) do
			if e:is(Slime) or e:is(SlimeBall) or e:is(SlimeCannon) then
				count = count + 1
			end
		end

		if count == 0 then
			local c = G.console
			st.outro_started = true
			---[[
			c:print("[TID 32] SATCOM ready.", 2)
			c:beep()
			for i = 1,3 do
				c:print("Initializing SATCOM link...attempt " .. i, 1.4, i > 1)
			end
			c:print("Connection established.", 1)

			c:print("Logging in...", 1)
			c:print("Authentication successful.", 2)
			c:print("Starting telemetry uplink stream (ch. 0x13).", 1)
			c:print("Telemetry link nominal.", 0.5)
			c:print("Starting telecommand downlink stream (ch. 0x14).", 2)
			c:print("Telecommand link nominal.", 0.5)
			c:print("")
			c:print("**********************************", 0.7)
			c:error()
			c:print("** EMERGENCY INTERRUPT RECEIVED **")
			c:print("**********************************") 
			c:print("")
			for i = 1, 5 do
				local s = ""
				for j = 1, i do
					s = s .. "."
				end
				c:print("Decoding TC packet" .. s, 0.8, i > 1)
			end

			c:print("Decoding TC packet.....done", 0.8, true)
			c:print("Packet contains 5 telecommands")

			c:print("Executing TC #0001: SFTY_LOCK_ENABLE")
			c:print("  * NOTICE: Enabling safety lock", 1)
			c:print("  * WARNING: Weapon systems offline.", 0.4)
			c:barrier(function()st:allowFire(false)end)
			c:print("Executing TC #0002: MOTOR_CTRL_SHUTDOWN")
			c:print("  * NOTICE: Motor controls shutting down", 1)
			c:print("  * NOTICE: TC execution successful", 0.4)

			c:barrier(function()
				st:killInput(true)
				st.player.speed[1] = 0
				st.player.speed[2] = 0
			end)

			c:print("Executing TC #0003: IFF_DATABASE_DOWNLOAD")
			for i = 0, 100 do
				c:print("Downloading friend/foe database: " .. i .. "% done", 0.05, i > 0)
			end
			c:print("Writing IFF DB to mass storage...")
			c:print("Writing IFF DB to mass storage...done", 1.5)
			c:beep()
			c:print("Executing TC #0004: MISSION_DATABASE_DOWNLOAD")
			for i = 0, 100 do
				c:print("Downloading mission database: " .. i .. "% done", 0.02, i > 0)
			end
			--]]
			c:print("Writing mission DB to mass storage...")
			c:print("Writing mission DB to mass storage...done", 1.5)
			c:beep()
			c:print("Executing TC #0005: SYSTEM_REBOOT")
			c:print("Shutting down visual system...", 1)
			c:barrier(function()
				st.tween:to(st.renderer.tint, 1, {[1]=0, [2]=0, [3]=0})
				end, 1)
			c:print("Vision offline.", 1.5)
			c:print("", 1)
			c:print("Rebooting system")
			c:clear(3)


			c:barrier(function ()
				st.color = st.newimage[1]
				for i, e in ipairs(st.entities.children) do
					if e:is(SlimeHurt) then
						if math.random() < 0.06 then
							e.dead = true
							e.group:add(DeadGuy(e.x, e.y, e.z))
						else
							e.img[1] = st.newimage[2]
							e.img[2] = st.newimage[3]
							e.a = 192
						end
					end
				end
				
			end)


			---[[
			c:beep(2)
			c:print("S.E.N.T.I.N.E.L. BIOS v1.17.2", 0)
			c:print("Power-on self test (POST)", 0.6)
			for i = 0, 1024, 4 do
				c:print("Memory: " .. (1024 * i) .. "M checked", 0.016, i > 1)
			end

			c:print("Detected anomalous memory blocks.")
			c:print("Isolating faulty memory area...", 0.1)
			c:print("Isolating faulty memory area...done", 1.3, true)
			c:print("Hardware checks:", 0.2)
			c:print("Mass storage:", 0.2)
			c:print("Mass storage:    present", 0.4, true)
			c:print("Cameras:", 0.2)
			c:print("Cameras:         present", 0.4, true)
			c:print("Audio processor:", 0.2)
			c:print("Audio processor: present", 0.4, true)
			c:print("Actuators:", 0.2)
			c:print("Actuators:       present", 0.4, true)
			c:print("Weapon systems:", 0.2)
			c:print("* B.A.D.A.S.S. Pulse Cannon:", 0.7)
			c:print("* B.A.D.A.S.S. Pulse Cannon: operational", 0.7, true)
			c:print("* Minigun turret:", 0.5)
			c:print("* Minigun turret:            offline", 0.2, true)

			c:print("", 0.6)
			c:print("Loading operating system...")
			

			c:print("")
			c:print("")
			c:beep(0)
			c:beep(0.2)
			c:print("Realtime S.E.N.T.I.N.E.L. loaded")
			c:print("Kernel 2.8.4.74532")
			c:print("Built: 2015-12-13")
			c:print("Booting secondary CPU cores:")
			--]]
			---[[
			for i = 1, 17 do
				local t = ""
				for j = 1, i do
					t = t .. " " .. ((j < 17) and j or "done")
				end
				c:print("  " .. t, 0.125, i > 1)
			end
			c:print("Loading primary mission database...")
			c:print("Loading primary mission database...done", 2, true)
			c:print("Opening SATCOM connection to HQ", 1)
			c:print("Connection established.", 0.3)
			c:print("Logging in...", 0.3)
			c:print("Authentication successful.", 0.6)
			c:print("Starting telemetry uplink stream (ch. 0x13).", 0.3)
			c:print("Telemetry link nominal.", 0.15)
			c:print("Starting telecommand downlink stream (ch. 0x14).", 0.6)
			c:print("Telecommand link nominal.", 0.15)
			c:print("Mission objectives:", 1)
			c:print("  1   DISENGAGE/NO ACTION", 0.3)
			c:print("  2   LOCK WEAPONS")
			c:print("")
			c:print("Loading primary IFF database...")
			c:print("Loading primary IFF database...done", 2, true)
			--]]
			c:print("Booting visual system...")
			c:barrier(function()
				st.tween:to(st.renderer.tint, 10, {[1]=255, [2]=255, [3]=255}):ease("quadin")
				end, 1)

			c:print("Vision stabilized", 4.5)
			c:print("")
			c:print("Calibrating actuator servo motors", 1)
			c:print("")
			c:print("NOT Enabling motor control", 0.4)
			c:print("Hull integrity: 100%", 0.3)
			c:beep(0)
			c:print("", 4)
			for i = 1, 30 do
				c:print("", 0.1)
			end
			c:clear(0)
			c:print("Thank you for playing.", 1)
			c:print("", 2)
			c:print("S.E.N.T.I.N.E.L.")
			c:print(" by rnlf/Florian Keßeler", 0.5)
			c:print("", 2)
			c:print("  made in 48h for the Ludum Dare 34 Compo")
			c:print("", 2)
			c:print("  contact: @_rnlf")
			c:print("  web:     base13.de")
		end
	end

}
