Group = Entity:extend()

function Group:new(x, y)
  Entity.new(self, x, y)
  self.children = {}
  self.named = {}
end


function Group:add(entity)
  if entity.dead then return end
  entity.group = self
  self.children[#self.children+1] = entity
  if entity.name then
    self.named[entity.name] = entity
  end
end


function Group:update(dt)
  for i = #self.children, 1, -1 do
    local e = self.children[i]
    if e.dead then
      self.children[i] = self.children[#self.children]
      self.children[#self.children] = nil
      if e.name then
        self.named[e.name] = nil
      end
    else
      e:update(dt)
    end
  end
end


function Group:draw(renderer)
  for i, e in ipairs(self.children) do
    if not e.dead then
      e:draw(renderer)
    end
  end
end
