lust = require "lust"
require "ingame"
require "console"


function love.load()
	G = {}
	
	G.core = lust.Core()

	G.font = love.graphics.newFont("data/SVBasicManual.ttf", 20)

	G.keyconfig = lust.KeyConfig(
		{"up",    "Walk Up",    "up"},
		{"down",  "Walk Down",  "down"},
		{"left",  "Walk Left",  "left"},
		{"right", "Walk Right", "right"},
		{"fire",  "Fire",       "x"}
	)

	G.console = Console()

	G.music = love.audio.newSource("data/audio/background.ogg", "static")
	G.music:setLooping(true)
	G.music:play()
	G.sounds = {}
	for i, n in ipairs({
		"badass",
		"cannon_spinup",
		"cannon_throw",
		"slime_spawn",
		"slime_die",
		"slime_hit",
		"slime_move",
		"step1",
		"console_beep",
		"console_error",
		"player_hit",
		"badass_preheat",
		"slime_melee",
		"player_dead"
	}) do
		G.sounds[n] = love.audio.newSource("data/audio/" .. n .. ".ogg", "static")
	end
	G.sounds.slime_move:setLooping(true)
	G.sounds.slime_move:setVolume(0.5)
	G.sounds.cannon_spinup:setVolume(0.8)

	G.core.states:push(IngameState("level01"))
end


function love.draw()
	G.core.states:draw()
	G.console:draw()
end


function love.update(dt)
	if love.keyboard.isDown("r") then
		G.console.lines = {}
		G.console.queue = {}
		G.console.curtime = 0
		G.core.states:replace(IngameState("level01"))
	end
	G.core.states:update(dt)
	G.console:update(dt)
end
