PlayerExplosion = Entity:extend()

function PlayerExplosion:new(x, y, z, movemesh, size, min, max)
--  self.attach = movemesh:locate(x, y, z)

  Entity.new(self, x, y, z)
  self.z = z

  self.img = G.core.images:load("data/sprites/bigbeam.png")
  self.img2 = G.core.images:load("data/sprites/smoke.png")

	local sx, sy = self.img:getDimensions()
	self.quad = G.core.quads:make(0,0,sx,sy,sx,sy)

	self.parts = {}
	local mi = {
		math.min(min[1], max[1]),
		math.min(min[2], max[2]),
		math.min(min[3], max[3]),
	}
	local ma = {
		math.max(min[1], max[1]),
		math.max(min[2], max[2]),
		math.max(min[3], max[3]),
	}
	for i = 1, size do
		local r = math.random() > 0.4
		self.parts[i] = {
			x, y, z,
			love.math.random(mi[1], ma[1]) / 15,
			love.math.random(mi[2], ma[2]) / 15,
			love.math.random(mi[3], ma[3]) / 15,
			love.math.random(1, 300) / 100,
			r and self.img or self.img2,
			r and "add" or "alpha",
			r and 0.7 or 0.6,
			r and 255 or (math.random() * 127),
			r and 255 or 0,
			r and (math.random() * (-64)) or (math.random() * 64 + 64)
		}
	end

	self.t = 1

end


function PlayerExplosion:draw(renderer)
	local t = math.min(1.0, self.t)
  for i, p in ipairs(self.parts) do
		renderer:add(p[8], self.quad, 10,10, p[1], p[2], p[3],
			p[9], p[7], p[7], p[11], p[11], p[11], p[12] * t, false, false )
	end
end

local function dampV(v, dt)
	local six = lust.tools.sig(v)
	return v - 15 * dt * six
end

function PlayerExplosion:update(dt)
  for i, p in ipairs(self.parts) do
		p[12] = math.max(0, math.min(255, p[12] + p[13] * dt))
		p[4] = dampV(p[4], dt)
		p[5] = dampV(p[5], dt)
		p[6] = dampV(p[6], dt) - 20*p[10]*dt

		p[1] = p[1] + p[4]
		p[2] = p[2] + p[5]
		p[3] = p[3] + p[6]
	end

	self.t = math.max(self.t - dt * 0.2, 0)

	if self.t == 0 then
		self.dead = true
	end
end
