SlimeBall = Entity:extend()

function SlimeBall:new(x, y, z, movemesh)
  self.attach = movemesh:locate(x, y, z)
	self.spawn = G.sounds.slime_spawn:clone()
	self.diesound = G.sounds.slime_die:clone()

  Entity.new(self, x, y, z)
  self.z = z

  self.img = G.core.images:load("data/sprites/slime_cannonball.png")

  self.frames = {}
	for i = 1, 20 do
		self.frames[i]    = quad(i, 50, 100, self.img)
  end

  self.frame = 1
  self.flux = flux.group()
  self.t = {col = 1}

  self.time = 0

	self.h = 10
	self.a = 255
	self.flux:to(self, 0.4, {h=20}):ease('quadin')
		:after(self, 0.6, {h=1}):ease('quadout')
			:oncomplete(function()
				for i = 1, 15 do
					local x, y = love.math.random(-20, 20), love.math.random(-10, 10)
					self.group:add(SlimeHurt(self.x+x, self.y+y, self.z, self.attach.mesh))
				end
				self.spawn:play()
				self.group:add(Slime(self.x, self.y, self.z, self.attach.mesh))
				self.flux:to(self, 0.1, {vx = 0, vy = 0, a=0}):ease('linear')
					:oncomplete(function()
						self.dead = true
					end)
			end)

  self.health = 50

	self.collaabb = {
		-20, -10,
		20, 10
	}

end


function SlimeBall:hurt(dmg)
	self.health = self.health - dmg
	if self.health < 0 then
		self.diesound:play()
		for i = 1, 15 do
			local x, y = love.math.random(-20, 20), love.math.random(-10, 10)
			self.group:add(SlimeHurt(self.x+x, self.y+y, self.z, self.attach.mesh))
		end
		self.dead = true
	end
end


function SlimeBall:draw(renderer)
  renderer:add(self.img, self.frames[math.floor(self.h)], 25, 82, self.x, self.y, self.z,
    "alpha", 1, 1, 255, 255, 255, self.a )
end


function SlimeBall:update(dt)
	local nx = self.x + self.vx * 1 * dt
	local ny = self.y + self.vy * 1 * dt

	local allow = self.attach:moveto(nx, ny)
	if allow then
		self.x = nx
		self.y = ny
		self.z = self.attach:height()

		local c, px, py = self.attach:collision(30)
		if c then
			local npx, npy = lust.tools.normalize(px, py)
			local s = npx*self.vx + npy * self.vy
			self.vx = self.vx + 1*s
			self.vy = self.vy + 1*s
			self.x = self.x + px
			self.y = self.y + py
		end

	end
	self.collaabb = {
		-17, -25 - self.h * 2.5,
		17, 10 - self.h * 2.5
	}
  self.flux:update(dt)
end
