SlimeHurt = Entity:extend()

function SlimeHurt:new(x, y, z, movemesh)
  self.attach = movemesh:locate(x, y, z)

	if not self.attach then
		self.dead = true
		return
	end

  Entity.new(self, x, y, z)
  self.z = z
	self.a = 128

  self.img = {G.core.images:load("data/sprites/slime_hurt.png"),
      G.core.images:load("data/sprites/slime_hurt2.png")
  }

  self.dir = love.math.random(1, 2)

  self.frames = {fly = {},
                 exist = {}}
	for i = 1, 20 do
		self.frames.fly[i]    = quad(i, 32, 64, self.img[1])
  end

  self.frames.exist[1] = self.frames.fly[20]

  self.frame = 1
  self.anim = "fly"
  self.flux = flux.group()
  self.t = {col = 1}
  self.flux:to(self.t, 2, {col = 0})
    :delay(1)
    :oncomplete(function()
      self.dead = true
    end)

  self.time = 0

  self.vx = love.math.random(-100, 100)
  self.vy = love.math.random(-100, 100)

end


function SlimeHurt:draw(renderer)
  renderer:add(self.img[self.dir], self.frames[self.anim][math.floor(self.frame)], 17, 55, self.x, self.y, self.z,
    "alpha", 1, 1, 255, 255, 255, self.a, true, false )
end


function SlimeHurt:update(dt)
    
    self.frame = self.frame + dt * 20
    if math.floor(self.frame) > #self.frames[self.anim] then
      self.frame = 1
      self.anim = "exist"
    end

    local six = lust.tools.sig(self.vx)
    self.vx = self.vx - 50 * dt * six
    if lust.tools.sig(self.vx) ~= six then
      self.vx = 0
    end

    local siy = lust.tools.sig(self.vy)
    self.vy = self.vy - 50 * dt * siy
    if lust.tools.sig(self.vy) ~= siy then
      self.vy = 0
    end

    local nx = self.x + dt * self.vx
    local ny = self.y + dt * self.vy
    local allow = self.attach:moveto(nx, ny)
    if allow then
      self.x = nx
      self.y = ny
      --self.z = self.attach:height()

      local c, px, py = self.attach:collision(8)
      if c then
        self.x = self.x + px
        self.y = self.y + py
      end

    end
--    self.flux:update(dt)
end
